;; Mirror Grammar
;; MPradella 25/3/2006

; S -> V S
; V, S -> A1 / A2 | B1 / B2 | a | b
; A2 -> V / A1 | a
; B2 -> V / B1 | b
; A1 -> a
; B1 -> b

(require (file "/home/pradella/docs/2d/mazpa/kolam.scm"))

(define *t-rules* 
  '(
    (a  A1 A2 S V)
    (b  B1 B2 S V)
    ))

(define *h-rules*
  '(
    ((V . S) S)
    ))

(define *v-rules*
  '(
    ((A1 . A2)  V S)
    ((B1 . B2)  V S)
    ((V . A1)   A2)
    ((V . B1)   B2)
    ))

(set-rules! *t-rules* *h-rules* *v-rules*)

;(toggle-trace!)

(parse!
  '((a b a a b a)
    (b b b a a a)
    (a a b a b b)
    (b b b a a a)
    (a b a a b a)))

